//+------------------------------------------------------------------+
//|                                                Structur_File.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <Structur_File.mqh>                                     |
//+------------------------------------------------------------------+
#include "Decode_MarketWatch.mqh"
//+------------------------------------------------------------------+
//| structure of binary data for passing to the EA in the tester     |
//+------------------------------------------------------------------+
struct STradesMT4
  {
public:
                     STradesMT4(void){};
                    ~STradesMT4(void){};
   datetime          time;
   double            price;
   double            volume;
   ushort            symbol;
   ushort            type;
   //--- encoding the deal type to ushort
   void              type(string sor){if(sor=="buy")type=0;else type=1;};
   //--- decoding the deal type to string
   string            type(){return(type==0?"buy":"sell");};
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CArrayTradesMT4
  {

public:
   int               size;
   STradesMT4        arr[];
                     CArrayTradesMT4(void){size=0;};
                    ~CArrayTradesMT4(void){};
   //--- changing the size of the array of structures
   int               Resize(int i){return(size=ArrayResize(arr,i));};
   //--- printing the array of structures to a binary file
   int               WriteBinFile(string folder_);
   //--- reading the binary file to the array of structures
   int               ReadBinFile(string folder_);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CArrayTradesMT4::WriteBinFile(string folder_)
  {
   int res=0;
   int han=FileOpen(folder_+".dat",FILE_WRITE|FILE_BIN);
   if(han!=INVALID_HANDLE)
     {
      res=(int)FileWriteArray(han,arr);
      FileClose(han);
     }
   else Print(__FUNCTION__+" File open failed "+folder_+".dat, error",GetLastError());
   ResetLastError();
   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CArrayTradesMT4::ReadBinFile(string folder_)
  {
   int res=0;
   int han=FileOpen(folder_+".dat",FILE_READ|FILE_BIN);
   if(han!=INVALID_HANDLE)
     {
      size=(int)FileReadArray(han,arr);
      FileClose(han);
     }
   else Print(__FUNCTION__+" File open failed "+folder_+".dat, error",GetLastError());
   ResetLastError();
   return(size);
  }
//+------------------------------------------------------------------+
